/**
 * The MIT License
 * Copyright © 2020 Luis Andrés Lange <http://javacomm.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package org.nexuswob.algorithm;



public class Hashing {

	private Object hashObject;
	private int M;
	
	
	public Hashing(int modulo) {
		M = modulo;
	}
	
	
	public Hashing(int modulo, Object obj) {
		hashObject = obj;
		M = modulo;
	}
	
	
	public void setHashObject(Object obj) {
		hashObject = obj;
	}
	
	
	public Object getHashObject() {
		return hashObject;
	}
	
	
	@Override
  public int hashCode() {
		StringBuffer buffer;
		int h;
		int keysize;
		
		if (hashObject==null) return 0;
		buffer = new StringBuffer(hashObject.toString());
		keysize = buffer.length(); 
		if (keysize<1) return 0;
		h = buffer.charAt(0);
		for (int index=0; index<keysize; index++) {
			h = (h*256 + buffer.charAt(index)) % M;
		}
		return h;
	}
	
}
